2022.9.21 Version 5.0.9.21

◇ 修正
1. 正则表达式功能可能出现的不支持Unicode问题。
2. 文件属性处理板块中的【2.3.文件属性备份还原】和【2.4.时间属性备份还原】中的“批量还原”功能导致属性文件列表的“文件或文件夹”列出现错误。
3. 判断闰年不全面的错误。

◇ 调整
1. 只要双击列表区域就执行被选中行的双击功能，调整为双击被选中行才执行双击功能。

◇ 增加
1. 文件属性处理板块中的【2.2.时间属性强制修改】增加了“修改日期”和“修改时间”的选项。
2. 文件属性处理板块中的【2.2.时间属性强制修改】增加了“模式1”和“模式2”，原来的内容为模式1，模式2为新增，可单独设置年月日时分秒。
3. 【4.E.2.图片EXIF拍摄信息强制修改】增加了“主IFD时间”修改项。
4. 【4.E.2.图片EXIF拍摄信息强制修改】增加了〖时间范围随机〗功能，在用户指定的时间范围中随机产生时间来批量修改EXIF的主IFD时间、拍摄时间或数码时间。
5. 【4.E.2.图片EXIF拍摄信息强制修改】增加了“同时修改文件时间属性”选项，可在修改主IFD时间、拍摄时间或数码时间的同时修改文件的创建时间和修改时间。


2022.6.9 Version 5.0.6.9

◇ 修正
1. 启动x86程序时弹出的致命错误对话框。
2. 在软件从未运行过的情况下，命令行安装资源管理器右键菜单出现的错误。

◇ 调整
1. 各文件列表中的文件大小列默认显示为友好文件大小，也可通过【参数设置->界面及文件列表显示】中的选项设置成字节文件大小。

◇ 增加
1. 【1.E.2.删除扩展名】将“删除第几个字符”修改为“删除/保留从指定位置开始的指定长度字符”。


2022.5.22 Version 5.0

◇ 修正
1. 在下拉编辑框中输入时，下拉编辑框总是强行变成不分大小写的、已被记录的字符串；已输入被执行时，已输入的文字被自动全选了。
2. 在更名之外的其它功能板块文件列表中移动或删除文件时，更名文件列表中任然存在已被移除的文件。
3. 更名命令中所有的字符串参数在保存时均进行了处理，载入批处理更名等操作不再出现空格被忽略的问题了。
4. 【1.A.11.文件名对照列表更名】中载入Excel文件时速度较慢的问题。
5. 【2.2.时间属性强制修改】板块中的以某时间为基数增减时间没考虑文件列表有文件未勾选的情况，导致时间增减量出问题。
6. 【参数设置】【常规】中，“在命令面板输入框中输入字符停止后内容自动执行：输入停止至执行间隔时间”变化后点击确定按钮不能立即应用。
7. 【3.E.A.高级标签编辑和文件信息】当标签种类为APE、FLAC、Opus新增标签时，点击板块中的“保存修改”按钮，会弹出错误对话框，并且保存不成功。
8. 【3.E.A.高级标签编辑和文件信息】板块点击“保存修改”按钮可能调用了未建立的对象的错误，并弹出错误对话框。
9. 文件列表为空时，改变过滤设置内容，小三角按钮仍然闪动提示执行。
10. “欢迎使用菲菲更名宝贝”对话框中，在用户账户控制(UAC)处于开启状态时，点击“上一条”“下一条”会出现错误。
11. 其它一些小问题的修正。

◇ 调整
1. 为增强与Windows11的兼容性，【载入文件】可同时载入多个文件，但不能同时载入文件夹；【载入文件夹】可同时载入多个文件夹，但不能同时载入文件；所有”定位选择文件夹“均改为系统对话框。
2. 增加载入各种编码格式文本文件的自动载入功能，避免载入方式不对出现乱码；增加各种打开和保存文件对话框的独立位置记忆和读取功能。
3. 【文件名编辑器】调整为可记忆的可自定义尺寸的窗口。
4. 【过滤设置】中的第10项导入文件名列表匹配功能进行了调整，改为5种匹配方式，不用再纠结是否含扩展名了。
5. 增加显示/隐藏功能面板（Ctrl+F1）、显示/隐藏命令列表（Ctrl+F2）、显示/隐藏底部消息栏（Ctrl+F3）快捷键。
6. 删除“帮助”菜单中的“帮助”项，改“欢迎使用菲菲更名宝贝”的快捷键为F1。
7. 软件使用最新开发平台版本编译，更新了最新的数据，进行了一些细节的调整。

◇ 增加
1. 支持Windows11。
2. 增加Python脚本更名功能。
3. 增加命令行载入文件方式，即exe后直接加若干文件作为参数，亦可将选择的文件拖拽至主执行文件上执行并载入。
4. 软件中的文件列表增加智能排序功能，类似于Windows资源管理器的排序。
5. 菜单【命令列表】中增加“最近打开的批处理命令”菜单列表，方便快速调用批处理文件。
6. 【1.N.2.替换】板块中的查找替换“编辑器”增加了保存和载入查找和替换字符串列表数据功能。
7. 增加网友互助用的目录树快照的生成和模拟还原工具。
8. 【1.S.C.1.多媒体文件名变更】板块增加了在获取时间时的UTC时间转本地时间和自由调节时间增减量的功能。
9. 各文件列表被选择的单元格的文本内容可用Ctrl-C进行复制。
10. 【音乐文件列表】表头增加“自动读取信息”复选框和“立即读取”按钮，可以手动读取信息了。
11. 增加命令行安装/卸载资源管理器右键菜单。安装为：FFRenamePro.exe -i  卸载为：FFRenamePro.exe -u
12. 在更名文件列表右键菜单增加了【移除所选项目】功能。


2020.9.5 Version 4.0

好几年了，断断续续的，更新内容过多，好些已经忘了，能记得、有记录的大致如下：

◇ 修正
1. 彻底解决有时弹出“Cannot create file "C:\Users\...\FFRenamePro[xxxxxxxxxxxxxx].ini".另一个程序正在使用此文件，进程无法访问。”的错误对话框。
2. 菜单中“重置程序所有参数配置并再次执行【自我修复】(&C)”功能存在的问题。
3. 读取APEv1标签内容的问题和写入APEv2时未能兼容原有的APEv1标签信息。
4. APEv2封面标签名称调整为大多数音乐播放软件使用的Cover Art (Front)。
5. 单个音乐文件保存歌词失败的问题。
6. 一些特殊的音乐格式如WMA、MP4、TwinVQ处理ID3v2的问题。
7. 【1.A.11.载入文件名对照列表更名】中由于文件名大小写导致匹配不上对照列表内容的问题。
8. 各文件列表右键【用资源管理器打开当前光标对象的位置(&X)】功能遇到含有空格的文件名不能准确定位的问题。
9. 除更名文件列表外的其他列表删除文件到回收站后文件在列表中仍然显示的问题。
10. 文本文件列表使用内部编辑器退出后的路径错误导致文件再次调用失败。
11. 在【欢迎使用菲菲更名宝贝】对话框中添加资源管理器右键菜单，关闭弹出的信息框后导致无法操作的问题。
12. 【1.A.1.正则表达式更名】即学即用中的匹配结果错误修正并改为列表显示。
13. 【1.S.O.Office文档文件】更名第1页“清除内存中的Office”按钮无反应。
14. 【1.N.4.自动编号】中同时选中“超出xx重置”和“排除xx”时编号有错误。
15. 继续完善对高DPI的支持。
16. 优化启动时的部分代码。
17. 其它问题的修正和完善。

◇ 调整
1. 大幅提高软件启动速度（重大更新）。
2. 界面功能板块进行了调整，功能分类更加明确，使用更加方便。
3. 文件归类板块从工具模式中移出，为主界面中一个独立的大功能板块。
4. 重写WMA（ASF）标签处理函数库，处理效率更高，调用功能更加准确。
5. 【4.E.2.图片EXIF拍摄信息强制修改】中，拍摄或数码时间“从文件名获取”功能改为新的获取匹配方式。
6. “音乐标签处理”功能大板块重新调整功能分布并调整版面，功能分类更加合理，使用更加方便。
7. 调整“对象过滤设置”对话框版面，内容分布更加合理。
8. 调整【2.文件属性处理】功能板块，内容分布更加合理。
9. 去除自定义皮肤功能。
10. 其它一些细节调整。

◇ 增加
1. 支持DSD(Direct Stream Digital)音乐格式的标签处理，包括DSF（SONY公司）和DFF（PHILIPS公司）的文件。
2. 支持AIFF（Apple公司）音乐格式的标签处理。
3. 文件归类板块功能大大增强，支持归类条件叠加等复杂的归类应用。
4. 元变量<DIR>功能大大增强，可从左到右或从右到左随意指定返回哪级文件夹字符串或哪个级别范围的文件夹字符串，还可返回盘符。
5. 【1.N.4.自动编号】中增加“分组”参数设定，默认为1，设定为n时，每n个文件为一组保持同一编号，以组为单位递增编号。
6. 【1.S.C.多媒体文件】更名板块的“总体信息”、“视频信息”和“音频信息”中均增加了“编码日期”和“标记日期”功能标签。
7. 文件过滤增加“导入文件名列表”功能，可使用户以已有的文件列表为基础从文件列表中挑选文件。
8. 文件过滤增加“文件路径匹配”系列功能，可根据文件路径来设置参数从文件列表中挑选文件。
9 文件过滤增加“以总共载入对象”还是“以更名文件列表现有对象”来过滤的选项，不同选择是有区别的。
10. “文件”菜单中增加“导入一个带路径的文件名列表文本文件(&F)”，多了一种软件载入文件方式。
11. 【2.2.时间属性强制修改】中增加了“匹配文件名来确定时间属性”功能。
12. 【文件名处理->常规->删除与保留】功能板块中的“从位置xxx删除xxx个字符”增加了“保留”功能。
13. 【文件名处理->常规->删除与保留】功能板块中的“删除以左xxx右xxx为间隔的字符串”增加了“保留”功能。
14. 【文件名处理->特定类型文件->多媒体】功能板块中增加了“编码日期”和“标记日期”标签及相应的日期时间格式处理。
15. 增加强大的单个音乐文件标签编辑功能，包括常用标签编辑和所有标签编辑。
16. 增加批量提取和批量嵌入歌词和图片板块，支持从指定文件夹内以用户定义的关键字条件挑选图片和歌词文件嵌入。
17. 增加9种音乐标签种类及其各种扩展标签项的批量修改功能。
18. “音乐标签处理”中部分功能增加了标签项的选择。
19. 增加程序启动时是否显示启动画面的选项；启动画面增加了显示和消失的切换特效。
20. 文件名批量更改PDF板块增加了页码尺寸宽高的提取。
21. 【1.A.高级(4)：语言脚本】更名板块增加了“Unix时间戳转换成时间”Pascal脚本示例。
22. 更改文件名时增加“如果改变文件扩展名，可能会导致文件不可用”的提示。

===================================

2015.12.25 Version 3.0

◇ 修正
1. 重大改进：预览、更名、撤销更名系列功能大量改进、修正和完善，智能更名效率更高、速度更快。请务必升级到此版本！！
2. 所有有关Office文档操作频繁弹出“发现已有Office程序运行”对话框的问题。
3. 当PDF文件不存在创建时间或修改时间时，读取器信息至功能面板会出错的问题。
4. 其它问题的修正和完善。

◇ 增加
1. 用户自定义元变量<USER>由1个改为10个，即<USER0>..<USER9>。
2. 需更名对象数量超过用户自定义数量值后弹出对话框，对话框可选择【简单更名】以加快更名处理，具体相关信息见【参数设置】“智能更名 (1)”页。
3. 【N.文件名变更】N.1至N.5板块均增加了左右间隔为界的字符串定位等方便用户的新功能。【N.文件名变更】板块尺寸加大，其它板块不变。
4. 增加【A.11.载入文件名对照列表更名】功能板块（第3页），可载入含文件名对照列表的文本文件或Excel文件进行更名。原【A.11.Pascal 脚本更名】改为A.12（第4页）。
5. 在【菜单->文件(F)】中增加【导出更名对照列表...(C)】功能，可将“实际文件名”和“新文件名”对照列表导出至文本文件或Excel文件。
6. 更名遇到同路径重名（含扩展名）对象时会自动加编号，这种自动编号在此版本中进行了功能扩展，可以选择数字或字母，也可以指定编号的增量和位数了。在参数设置中设置。
7. 增加预览或更名处理进度终止功能，按ESC键弹出对话框并确认后终止。（针对文件名更名动作真正开始后将禁止终止）
8. 【A.4.数字与汉字的转换】板块增加“数字直译（不含数学单位）”和转换汉字序号功能。
9. 【A.10.其它】功能板块增加“拉丁字母转换成最接近的英文字母”功能。
10. 在【菜单->编辑查看(V)】中增加【清空所有下拉编辑框的历史记录(H)】功能。
11.在有关Office文件更名或批量修改的相应板块中加入了“清除内存中的Office”按钮。
12.【α.2.文件属性强制修改】增加软件启动时自动载入上次使用过的时间。

===================================

2015.4.1 Version 2.2

◇ 修正
1. 更新音乐文件标签处理代码。
2. 修正程序部分操作中出现的is not a valid integer value错误提示。

◇ 增加
1. 支持 Windows8.1、Windows10。
2. 【N.2.替换】增加替换范围设置选项。
3. 【A.1.正则表达式更名】增强匹配替换取值设置选项的功能。
4. 文件属性和时间属性增加备份和还原功能。
5. 在帮助菜单中增加“系统用户账户控制（UAC）设置”功能，可快速彻底关闭UAC。
6. 软件参数设置中增加“在命令面板输入框中输入字符停止后内容自动执行”的选项，原间隔时间设置不变。
7. 音乐信息编辑查看对话框增加“上一个”和“下一个”按钮。
8. 音乐信息编辑查看对话框载入音乐文件时自动跳转到有图片和有歌词的标签页。

===================================

2014.12.18 Version 2.1

◇ 修正
1. FLAC标签处理的一处错误。
2. 修正Windows程序文件名变更时的一处代码漏洞。
3. 全面修正音乐文件标签读取或写入时的错误和漏洞，增加兼容性。
4. 默认皮肤启动的时候右上角会出现重叠字。
5. 其它问题的修正和完善。

◇ 增加
1. 增加原生WAV音乐标签的支持，可提取或修改WAV格式文件中的WAV标签。
2. 音乐文件列表增加强大的单个音乐文件信息编辑查看功能。
3. 文本文件列表增加内置文本编辑器，支持ANSI、UTF8、UTF16和UTF32编码的文本文件编辑，支持内码转换。
4. 加强Pascal脚本更名功能，增加Delphi XE7中的12个RTL库和1个VCL库的所有定义及函数均可使用。
5. 【S.特定文件文件名变更】板块中各文件种类子版块均保证有“去除数据前后空格”的选项。
6. 增加更名完毕后不再弹出结果对话框的选项。

===================================

2014.10.31 Version 2.0

◇ 修正
1. 修正刷新更名文件列表的一处错误。
2. 修正XP下无法提取PDF文件属性更名的错误。
3. 修正XP下无法正常使用文件时间属性过滤的错误。
4. 调整更名面板中各个下拉编辑框条目的记录和挤出方式。
5. 安卓APK程序文件名变更中无法辨认特殊字符文件名问题修正。
6. 【β.1.6】小板块中的音轨标签在使用数字序号时改为直接替换修改。
7. 其它问题的修正和完善。

◇ 增加
1. 增加智能分析文件获取扩展名。
2. 增加Windows程序文件信息的提取更名功能。
3. 增加多媒体（视频、音频、图像等）文件信息的提取更名功能。
4. 增加Pascal脚本更名功能。
5. 文件名编辑器增加含文件扩展名一同处理的选项和文本编辑相关功能。
6. 文件名内码转换增加Unicode转换选项。
7. 【N.4.自动编号】增加超出数字时重置功能
8. 增加刷新直接执行过滤功能，并在之后停止过滤小三角按钮闪烁。

===================================

2014.9.26 Version 1.9

◇ 修正
1. 撤销更名出现错误的问题。
2. 增加音乐文件APEv2标签读取或写入时的兼容性。
3. 修正一个文件占用的判断错误。
4. 其它问题的修正和完善。

◇ 增加
1. 软件启动封面。
2. 增加【N.6.字母大小写】例外功能。
3. 文件列表的右键菜单增加“反选所有复选框”功能。
4. 增加更名文件列表中文件夹一键遍历功能。
5. 增加更名文件列表按文件名或路径字符串长度过滤。
6. 元变量<DIR>增加自行设置参数，可定义取多少个级别的父文件夹名称。

===================================

2014.9.8 Version 1.8

◇ 修正
1. 安卓APK程序文件名变更中提取中文软件名的小问题再次修正。
2. 其它问题的修正和完善。

◇ 增加
1. 工具模式：增加了强大的文件归类功能。
2. 增加4个元变量：
   同路径文件总大小 <SPSIZE>
   文件夹下文件总大小 <DIRSIZE>
   文件列表内文件编号 <SAMPLENO>
   用户自定义 <USER>
3. 增加【S.D.2.与EXIF拍摄时间有关的数码照片文件名变更（宝宝多大了）】板块。
4. 【A.1.正则表达式更名】板块功能增加“指定批次匹配替换”和“只取指定批次的匹配替换值”的选项。
5. 【A.1.正则表达式更名】板块完成正则表达式“即学即用模式”。
6. 【β.2.2.图片EXIF拍摄信息强制修改】板块增加“拍摄时间”或“数字时间”的“年月日时分秒”时间单位的增减修正功能。
7. 【β.2.2.图片EXIF拍摄信息强制修改】板块增加“纬度”和“经度”的“小数纬度经度转换编辑器”，用来将小数度数转换成“度分秒”格式。
8. 【A.4.数字与汉字的转换】板块增加“文件名内数字自动识别功能”，不必只有整个文件名是数字时才能用这个板块的功能。
9. 【A.文件名变更（高级）】板块中的【A.9.其它】中增加“文件列表内文件名错位”功能。

===================================

2014.8.6 Version 1.6

◇ 修正
1. 安卓APK程序文件名变更中提取中文软件名的一个问题修正。
2. 其它问题的修正和完善。

◇ 增加
1. 批量更名时冲突文件名的提示和智能更名功能。详细介绍见：
   http://www.ffhome.com/works/ffrenamepro/1540.html
2. 批量更名后更名文件列表中的状态列显示：绿色为更名成功，黄色为跳过，红色为失败。
3. 【A.文件名变更（高级）】板块中的【A.9.其它】中增加“文件列表内文件名对调”功能。

===================================

2014.7.22 Version 1.5

◇ 修正
1. 选择“汉字转英文字母串拼音（A.3.汉字转拼音）”和“文件名字符顺序之两两对调（A.9.其它）”后新文件名中仍保留原文件名的问题修正。
2. 大幅提高x86版软件启动速度。
3. 当处理的文件被占用时弹出内存错误对话框问题的修正。
4. 其它问题的修正和完善。

◇ 增加
1. “S.特定文件文件名变更”中增加安卓APK程序文件名变更板块。
2. 调整“β.1.更改音乐文件标签”功能：
（1）原【常规】和【扩展】两页变更为四页，【第1页】不变；
（2）【第2页】中的【歌词和封面图片处理】板块进行了调整并增加了“所有音乐文件写入同一图片”功能；
（3）【第2页】增加功能强大的“β.1.6.常用音乐标签内容再修改”板块；
（4）【第3页】增加“β.1.7.常用音乐标签内容导出和导入文本编辑修改”功能；
3. 在【N.3.删除】中增加“去除两端空格”功能。
4. 消息栏增加右键菜单和“消息栏内容查看器”，双击消息栏即可放大显示消息内容。

===================================

2014.4.27 Version 1.2

◇ 修正
1. 更名命令面板可随意更改高度的问题修正。
2. 其它问题的修正和完善。

◇ 增加
1. <SIZE>元变量（返回文件大小）提供自行设置：文件大小自动，字节、KB、MB、GB以及逗号分隔千分位等多种返回值形式。
2. 更名文件列表右键菜单增加“随机排序”功能。
3. 【N.3.删除】删除（或保留）指定字符串功能用户可定义多个字符串，多个字符串之间请使用“|”分隔。
4. 软件界面自适应系统DPI功能。

===================================

2014.3.20 Version 1.1

◇ 修正
1. 【A.1.1.变量匹配更名】载入更名命令时无法执行的错误修正。
2. 【更改文本文件内容】板块载入时遇到被占用的文件时中断的问题修正。
3. 调整所有数字输入框的最大值最小值范围，使之更为合理。
4. 其它问题的修正和完善。

◇ 增加
1. 【N.文件名变更】中增加【N.5.移动】子板块（原字母大小写子板块编号改为N.6）。
2. 【β.2.2.图片EXIF拍摄信息强制修改】中增加：①从文件名字符串中获取时间信息②获取文件时间属性信息，修改EXIF信息的“拍摄时间”或“数字时间”。
3. 增加2个元变量：
   文件名中指定子字符串.实际 <SUBSTR>
   文件名中指定子字符串.当前 <CSUBSTR>
4. 当用户改变过滤保留或过滤排除编辑框时，执行按钮小三角闪烁提醒用户执行过滤。

===================================

2014.2.25 Version 1.0

◇ 修正
1. 全局UAC判断的一个错误修正。
2. 解决文件处理进度时出现未响应的问题。
3. 修正下拉框中和元变量值头尾是空格时再次启动软件丢失的问题。
4. 其它问题的修正和完善。

◇ 增加
1. 增加8个元变量：
   同路径文件和文件夹总数 <SPALLNUM>
   同路径文件总数 <SPFILENUM>
   同路径文件夹总数 <SPDIRNUM>
   文件夹下文件和子文件夹总数 <DIALLNUM>
   文件夹下文件总数 <DIFILENUM>
   文件夹下子文件夹总数 <DIDIRNUM>
   文件列表对象总数 <LISTNUM>
   文件夹下文件名包含的字符串 <DIFNSUBSTR>
2. 更名文件列表右键增加【隐藏所选项目】和【显示隐藏项目】功能。
3. 除更名文件列表外的其他文件列表上的迷你工具栏增加【将当前列表对象导入更名文件列表去更名】功能。

===================================

2014.2.1 Version 1.0 公开测试版1

◇ 修正
1. 部分错误修正和优化代码。

===================================

2014.1.29 Version 1.0 内部测试版2

◇ 修正
1. 全面兼容Windows Vista以上系统【用户账户控制(UAC)】开启的情况。

===================================

2014.1.26 Version 1.0 内部测试版1

◇ 菲菲更名宝贝 之 得意非凡 v1.0 内部测试版1 发布